require 'rubygems'

require 'active_support'
require 'active_support/core_ext'
require 'active_support/json'
require 'active_support/inflector'
require 'active_support/notifications'

require 'set'
require 'uri'
require 'hashie/mash'

require 'logger'
require 'uuidtools'
require 'rubygems/package'
require 'zlib'
require 'tempfile'
require 'settingslogic'

require 'occi4/extensions/hashie'

require 'occi4/helpers/inspect'
require 'occi4/helpers/comparators'

require 'occi4/errors'
require 'occi4/settings'
require 'occi4/log'
require 'occi4/version'
require 'occi4/core'
require 'occi4/infrastructure'
require 'occi4/collection'
require 'occi4/parser'
require 'occi4/model'

module Occi

  def kinds
    Occi::Core::Kinds.new
  end

  def mixins
    Occi::Core::Mixins.new
  end

  def actions
    Occi::Core::Actions.new
  end

  # @return [Array] list of Occi::Core::Categories
  def categories
    self.kinds + self.mixins + self.actions
  end
end
